#include <iostream>
#include <stdlib.h>
#include <sys/time.h>

using namespace std;

#ifndef N
#define N 8192
#endif

double a[N][N];

double getTime()
{
	struct timeval tv;
	gettimeofday(&tv, NULL);
	return tv.tv_sec + tv.tv_usec * 0.000001;
}

main()
{
	double t0;
	int i, j;
	double sum;

	for (i=0; i<N; i++) {
		for (j=0; j<N; j++) {
			a[i][j] = i/(j+1);
		}
	}

	sum = 0;
	t0 = getTime();
	for (i=0; i<N; i++) {
		for (j=0; j<N; j++) {
			sum += a[i][j];
		}
	}
	cout << "Row-wise: " << (getTime()-t0) << "s, sum = " << sum << "\n";

	sum = 0;
	t0 = getTime();
	for (j=0; j<N; j++) {
		for (i=0; i<N; i++) {
			sum += a[i][j];
		}
	}
	cout << "Column-wise: " << (getTime()-t0) << "s, sum = " << sum << "\n";
}


